datablock StaticShapeData(CommandPost) {
	className = "crate";
	shapeFile = "stackable2l.dts";

	maxDamage      = 5.0;
	destroyedLevel = 5.0;
	disabledLevel  = 4.7;

	explosion      = HandGrenadeExplosion;
	expDmgRadius = 1.0;
	expDamage = 0.05;
	expImpulse = 200;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Command';
    targetTypeTag = 'Post';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
    needsPower = false;
};

datablock StaticShapeData(ControlStation) : StaticShapeDamageProfile {
   className = Station;
   shapeFile = "station_teleport.dts";
   maxDamage = 2.0;
   destroyedLevel = 2.0;
   disabledLevel = 1.5;
   explosion      = DeployablesExplosion;
      expDmgRadius = 8.0;
      expDamage = 0.35;
      expImpulse = 500.0;

   dynamicType = $TypeMasks::StationObjectType;
   isShielded = false;
   energyPerDamagePoint = 110;
   maxEnergy = 50;
   rechargeRate = 0.20;
   renderWhenDestroyed = false;

   deployedObject = true;
   Invincible = true;

   cantAbandon = 1;

   cmdCategory = "DSupport";
   cmdIcon = CMDStationIcon;
   cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
   targetNameTag = 'Computer';
   targetTypeTag = 'Station';

   debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
   heatSignature = 0;
};

function ControlStation::onCollision(%data, %obj, %col) {
   if(%col.getDatablock().className !$= "Armor" || %col.client $= "") {
      return;
   }
   if(%obj.team != %col.team) {
      return;
   }
   if(%obj.getMountNodeObject(0) == 0 && %col.mountVehicle){
      %obj.mountObject(%col, 0);
      //push the Command Console
      //echo(%obj.hudToPush);
      %col.client.attachedCom = %obj.hudToPush;
      %col.attachedObj = %obj;
      %obj.attached = %col;
      messageClient(%col.client, 'OpenHud', "", 'scoreScreen' SPC "scoreScreen");
      Game.updateScoreHud(%col.client, 'scoreScreen' SPC "scoreScreen");
   }
}

function ControlStation::hasDismountOverrides() {
   return false;
}
