datablock StaticShapeData(ResourceSpire) {
	className = "crate";
	shapeFile = "stackable5l.dts";

	maxDamage      = 5.0;
	destroyedLevel = 5.0;
	disabledLevel  = 4.7;

    invincible = true;

	explosion      = HandGrenadeExplosion;
	expDmgRadius = 1.0;
	expDamage = 0.05;
	expImpulse = 200;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Resource';
    targetTypeTag = 'Spire';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
    needsPower = false;
};

function SpireLoop(%target, %ownerCl) {
   if(%target.team != %ownerCl.team) {   //stolen from us :P
      return;
   }
   %ownerCl.credits += 25;
   schedule(5000, 0, "SpireLoop", %target, %ownerCl);
}

datablock StaticShapeData(ResourceZone) {
	className = "crate";
	shapeFile = "stackable3m.dts";

	maxDamage      = 5.0;
	destroyedLevel = 5.0;
	disabledLevel  = 4.7;
 
    invincible = true;

	explosion      = HandGrenadeExplosion;
	expDmgRadius = 1.0;
	expDamage = 0.05;
	expImpulse = 200;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Resource';
    targetTypeTag = 'Mine';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
    needsPower = false;
};

function placeRandomResourceZones() {
   %group = nameToID("DefconResources");
   if(%group == -1) {
      error("PlaceRandomResourceZones: Group Not Found 'DefconResources'. Creating, and reattempting in 3 seconds.");
      %group = new SimGroup("DefconResources");
      schedule(3000, 0, "placeRandomResourceZones");
      return;
   }
   else {
      %rand = getRandom(4, 10);
      echo("placeRandomResourceZones: Placing "@%rand@" zones on the map");
      for(%i = 0; %i < %rand; %i++) {
         %zonePos = RMPG();
         %zone[%i] = new StaticShape() {
            datablock = "ResourceZone";
            position = %zonePos;
            team = 0;
         };
         if (%zone[%i].getTarget() != -1) {
            setTargetSensorGroup(%zone[%i].getTarget(), 0);
         }
         %zone[%i].isResourceMine = 1;
         %group.add(%zone[%i]);
      }
      //spires
      %srand = getRandom(1, 5);
      echo("placeRandomResourceZones: Placing "@%srand@" spires on the map");
      for(%i = 0; %i < %srand; %i++) {
         %spirePos = RMPG();
         %spire[%i] = new StaticShape() {
            datablock = "ResourceSpire";
            position = %spirePos;
            team = 0;
         };
         if (%spire[%i].getTarget() != -1) {
            setTargetSensorGroup(%spire[%i].getTarget(), 0);
         }
         %spire[%i].isResourceSpire = 1;
         %group.add(%spire[%i]);
      }
   }
}
