//Commander Dalhart
//Special Ability: Capital Blast (6:00) Calls in Orbital Gauss Shells
//Gauss Hunter (1750[D1])
//No Devastator
//No Heavy Collectors
datablock ParticleData(GaussSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.02;
   inheritedVelFactor   = 0.1;

   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 100;

   textureName          = "particleTest";

   useInvAlpha = false;
   spinRandomMin = -90.0;
   spinRandomMax = 90.0;

   colors[0]     = "1 1 1";
   colors[1]     = "1 1 1";
   colors[2]     = "1 1 1";
   sizes[0]      = 1;
   sizes[1]      = 1.2;
   sizes[2]      = 1.4;
   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(GaussSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 1.5;
   velocityVariance = 0.3;

   thetaMin         = 0.0;
   thetaMax         = 50.0;

   particles = "GaussSmokeParticle";
};

datablock LinearFlareProjectileData(GaussBullet) {
   projectileShapeName = "weapon_missile_projectile.dts";
   scale               = "1.0 1.0 1.0";
   faceViewer          = true;
   directDamage        = 0.55;
   hasDamageRadius     = true;
   DamageRadius        = 10;
   IndirectDamage      = 0.45;
   kickBackStrength    = 6400;
   radiusDamageType    = $DamageType::Gauss;

   explosion           = "SatchelMainExplosion";
   splash              = ChaingunSplash;

   baseEmitter        = GaussSmokeEmitter;

   dryVelocity       = 3000.0;
   wetVelocity       = 2000.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   //activateDelayMS = 100;
   activateDelayMS = -1;

   size[0]           = 0.2;
   size[1]           = 0.5;
   size[2]           = 0.1;

   numFlares         = 5;   //less flares = less lag
   flareColor        = "1 0.18 0.03";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   hasLight    = true;
   lightRadius = 10.0;
   lightColor  = "0.94 0.03 0.12";
};

function LaunchCapitolStrike(%client, %position) {
//   echo("Resetting client Var 1");
   $SWTimer["CapitolStrike", %client] = 360;
//   echo("Resetting client Var 2");
   %client.canFireCapitol = 0;
//   echo("Picking RND");
   if(%client.CP.DefconLevel > 1) {
      %rnd = getRandom(7,10);
      for(%i = 0; %i < %rnd; %i++) {
         %time = 5000 + (%i * 1750);
         %posToStrike = VectorAdd(%position, getRandomPosition(30, 0));
         %posToStrike2 = VectorAdd(%posToStrike, "0 0 3000");
         schedule(%time, 0, "SpawnProjectile", "GaussBullet", "LinearFlareProjectile", %posToStrike2, "0 0 -3", "");
      }
      $SWBeacon[%client] = new StaticShape() {
         datablock = "OrdersReticle";
         position = %position;
         team = %client.team;
         scale = "15 15 1";
      };
      MissionCleanup.add($SWBeacon[%client]);
      $SWBeacon[%client].schedule((5000+(%rnd*1750)), "delete");
   }
   else {
      %rnd = getRandom(15,30);
      for(%i = 0; %i < %rnd; %i++) {
         %time = 2500 + (%i * 750);
         %posToStrike = VectorAdd(%position, getRandomPosition(36, 0));
         %posToStrike2 = VectorAdd(%posToStrike, "0 0 3000");
         schedule(%time, 0, "SpawnProjectile", "GaussBullet", "LinearFlareProjectile", %posToStrike2, "0 0 -3", "");
      }
      $SWBeacon[%client] = new StaticShape() {
         datablock = "OrdersReticle";
         position = %position;
         team = %client.team;
         scale = "20 20 1";
      };
      MissionCleanup.add($SWBeacon[%client]);
      $SWBeacon[%client].schedule((2500+(%rnd*750)), "delete");
   }
}

function CapitolStrikeLoop(%client) {
   if($SWTimer["CapitolStrike", %client] > 0) {
      $SWTimer["CapitolStrike", %client]--;
      if($SWTimer["CapitolStrike", %client] == 0) {
         MessageClient(%client, 'MsgReady', "\c5Defcon: Capitol Blast. Ready to fire, awaiting coordinates...");
         %client.canFireCapitol = 1;
      }
   }
   schedule(1000, 0, "CapitolStrikeLoop", %client);
}
