//Commander Phantom
//Special Ability 1: Superior Anomety: All units have power shields, but cost 250 more
//Special Ability 2: Defcon Superiority: Start at Defcon 1, but cannot build missile silos
//Special Ability 3: Plasma Storm (4:30): Unleashes a burst of power plasma shells
//Reaper Drone: Cost: 800: Armed with dual missile cannons
//Savager: Cost: 1250: Armed with Pulse Cannons
//Ultitron: Cost: 3500: Armed with dual railguns

datablock LinearFlareProjectileData(PlasmaStormBolt) {
   doDynamicClientHits = true;

   directDamage        = 0;
   directDamageType    = $DamageType::PlasmaTurret;
   hasDamageRadius     = true;
   indirectDamage      = 0.6;
   damageRadius        = 20.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::PlasmaTurret;
   explosion           = MortarExplosion;
   splash              = PlasmaSplash;

   dryVelocity       = 500.0;
   wetVelocity       = -1;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 30000;
   lifetimeMS        = 30000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = 100;

   scale             = "4.5 4.5 4.5";
   numFlares         = 30;
   flareColor        = "1.0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

function LaunchPlasmaStorm(%client, %position) {
//   echo("Resetting client Var 1");
   $SWTimer["PlasmaStorm", %client] = 270;
//   echo("Resetting client Var 2");
   %client.canFirePlasmaStorm = 0;
   %rnd = getRandom(20,25);
   for(%i = 0; %i < %rnd; %i++) {
      %time = 2500 + (%i * 750);
      %posToStrike = VectorAdd(%position, getRandomPosition(36, 0));
      %posToStrike2 = VectorAdd(%posToStrike, "0 0 1000");
      schedule(%time, 0, "SpawnProjectile", "PlasmaStormBolt", "LinearFlareProjectile", %posToStrike2, "0 0 -3", "");
   }
   $SWBeacon[%client] = new StaticShape() {
      datablock = "OrdersReticle";
      position = %position;
      team = %client.team;
      scale = "20 20 1";
   };
   MissionCleanup.add($SWBeacon[%client]);
   $SWBeacon[%client].schedule((2500+(%rnd*750)), "delete");
}

function PlasmaStormLoop(%client) {
   if($SWTimer["PlasmaStorm", %client] > 0) {
      $SWTimer["PlasmaStorm", %client]--;
      if($SWTimer["PlasmaStorm", %client] == 0) {
         MessageClient(%client, 'MsgReady', "\c5Defcon: Plasma Storm. Ready to fire, awaiting coordinates...");
         %client.canFirePlasmaStorm = 1;
      }
   }
   schedule(1000, 0, "PlasmaStormLoop", %client);
}

function BeginShieldUnit(%unit) {
   %unit.isPowerShielded = true;
   setTargetName(%unit.target, addtaggedstring("Shielded "@%unit.name@""));
   ShieldDomeLoop(%unit);
}

function ShieldDomeLoop(%unit) {
   if(!isAlive(%unit)) {
      return;
   }
   %unit.playShieldEffect("1 1 1");
   schedule(250, 0, "ShieldDomeLoop", %unit);
}
