//Singe Gun
//Collect Resources!!!
datablock ShapeBaseImageData(SingeGunImage) {
   className = WeaponImage;
   shapeFile = "weapon_energy.dts";
   item = SingeGun;
   
   projectile = EnergyBolt;             //this matters not!
   projectileType = EnergyProjectile;

   usesEnergy = true;
   fireEnergy = 4;
   minEnergy = 4;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = BlasterSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 1.0;
   stateFire[3] = true;
   stateRecoil[3] = NoRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateSound[3] = SingeSound;
   stateScript[3] = "onFire";

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6] = "DryFire";
   stateTimeoutValue[6] = 0.3;
   stateSound[6] = BlasterDryFireSound;
   stateTransitionOnTimeout[6] = "Ready";
};

datablock ItemData(SingeGun) {
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_energy.dts";
   image = SingeGunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Singe Gun";
};

function SingeGunImage::onFire(%data, %obj, %slot) {
   //Initial Sets:
   if(%obj.client.MaxLoad $= "") {
      %obj.client.MaxLoad = 75;
   }
   if(%obj.client.TicksPerGrab $= "") {
      %obj.client.TicksPerGrab = 5;
   }
   if(%obj.Load $= "") {
      %obj.Load = 0;
   }
   //
   %muzzlePos = %obj.getMuzzlePoint(%slot);
   %muzzleVec = %obj.getMuzzleVector(%slot);
   %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 5));
   %Mask = $TypeMasks::StaticShapeObjectType;

   %hit = ContainerRayCast(%muzzlePos, %endPos, %Mask, %obj);
   if(%hit) {
      if(%hit == %obj.client.CP) {
         if(%obj.Load > 0) {
            %obj.client.credits += %obj.Load;
            messageClient(%obj.client, 'MsgLoad', "\c5Singe Gun: Supplied "@%obj.Load@" credits, you now have "@%obj.client.credits@" Credits.");
            %obj.Load = 0;
            ServerPlay3D(CashInSound, %obj.getPosition());
            return;
         }
         else {
            messageClient(%obj.client, 'MsgLoad', "\c5Singe Gun: You don't have any resources loaded.");
            return;
         }
      }
      else if(%hit.isResourceMine) {
         if(%obj.Load >= %obj.client.MaxLoad) {
            BottomPrint(%obj.client, "Maximum Resource Load Obtained ("@%obj.load@"/"@%obj.client.MaxLoad@")", 1, 1);
            return;
         }
         else {
            %obj.load += %obj.client.TicksPerGrab;
            if(%obj.load > %obj.client.MaxLoad) {
               %obj.load = %obj.client.MaxLoad;
            }
            BottomPrint(%obj.client, "Collecting: "@%obj.load@"/"@%obj.client.MaxLoad@" Obtained", 1, 1);
         }
      }
   }
   else {
      messageClient(%obj.client, 'MsgLoad', "\c5Singe Gun: must be looking at a CP or Resource Mine (5 Meter Range).");
      return;
   }
}

//Singe Gun Upgrades:
$Cost::SingeGun["MaxLoad100"] = 750;
$Cost::SingeGun["MaxLoad125"] = 1000;
$Cost::SingeGun["MaxLoad150"] = 1250;
$Cost::SingeGun["MaxLoad175"] = 1500;
$Cost::SingeGun["MaxLoad200"] = 2000;

$Cost::SingeGun["TicksPerGrab10"] = 1250;
$Cost::SingeGun["TicksPerGrab15"] = 2000;
$Cost::SingeGun["TicksPerGrab20"] = 3000;
//
//
function DoSingeGunUpgradeCheck(%client, %index, %tag) {
   if(%client.MaxLoad $= "") {
      %client.MaxLoad = 75;
   }
   if(%client.TicksPerGrab $= "") {
      %client.TicksPerGrab = 5;
   }
   messageClient( %client, 'SetLineHud', "", %tag, %index, "Resource Capacity: "@%client.MaxLoad@".");
   %index++;
   messageClient( %client, 'SetLineHud', "", %tag, %index, "Resources Gathered Per Shot: "@%client.TicksPerGrab@".");
   %index++;
   messageClient( %client, 'SetLineHud', "", %tag, %index, "");
   %index++;
   switch(%client.MaxLoad) {
      case 75:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tMaxLoad100\t1>Increase Max Load To 100 ("@$Cost::SingeGun["MaxLoad100"]@" Credits)</a>");
         %index++;
      case 100:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tMaxLoad125\t1>Increase Max Load To 125 ("@$Cost::SingeGun["MaxLoad125"]@" Credits)</a>");
         %index++;
      case 125:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tMaxLoad150\t1>Increase Max Load To 150 ("@$Cost::SingeGun["MaxLoad150"]@" Credits)</a>");
         %index++;
      case 150:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tMaxLoad175\t1>Increase Max Load To 175 ("@$Cost::SingeGun["MaxLoad175"]@" Credits)</a>");
         %index++;
      case 175:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tMaxLoad200\t1>Increase Max Load To 200 ("@$Cost::SingeGun["MaxLoad200"]@" Credits)</a>");
         %index++;
   }
   //TICKS PER GRAB
   switch(%client.TicksPerGrab) {
      case 5:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tTicksPerGrab10\t1>Increase Load Per Shot to 10 ("@$Cost::SingeGun["TicksPerGrab10"]@" Credits)</a>");
         %index++;
      case 10:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tTicksPerGrab15\t1>Increase Load Per Shot to 15 ("@$Cost::SingeGun["TicksPerGrab15"]@" Credits)</a>");
         %index++;
      case 15:
         messageClient( %client, 'SetLineHud', "", %tag, %index, "<a:gamelink\tBuyUpgrade\tTicksPerGrab20\t1>Increase Load Per Shot to 20 ("@$Cost::SingeGun["TicksPerGrab20"]@" Credits)</a>");
         %index++;
   }
   return %index;
}
